 {02.11.13 : -Added automatic port reopen function
              in Multi Socket Service with reopen
              counter at HTML index. (Saved as LA6WNA Web server4.3)
  18/11-13 : -Changed I2Ccs-pin from 27 to 24. Pin 27 seems to be defective.
  19/11-13 : -Added HTML code for home ventilation system.(Saved as LA6WNA Web server5.0)
  26/11-13 : -Added HTML code for snow depth at my cabin. (Saved as LA6WNA Web server5.1)           
  25/12-13 : -Added HTML code for status windgenerator at cabin page.
  19/5-14  : -Added data from hydro power station (saved as V5.3)
  25/6-15  : -Added data from garden controller. (saved as V5.4) }

CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  BUFFER_2K     = $800
  
  CR            = $0D
  LF            = $0A
  RESET_PIN     = 4 '26
  SOCKETS       = 4
  
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE

  DHCP_ATTEMPTS = 10

  USB_Rx          = 31
  USB_Tx          = 30
  
  { DHCP Lease Counter }
  CNT_PIN         = 7
  NCO_FREQ        = 610         '($8000)(80x10^6)/2^32 = 610.3516Hz                           
  FREQ_610        = $8000       ' AN001-P8X32ACounters-v2.0_2.pdf (page 6)

  DHCP_SOCKET     = 3

  I2Crxtx     = 25            'I2C data-pin
  I2Cclk      = 26            'I2C clock-pin
  I2Ccs       = 24            'I2C chipselect-pin
  BTS         =10             'Number of bytes to send to I2C-cog       (MAX 500)
  BTR         =213            'Number of bytes to receieve from I2C-cog.(MAX 500)
  LED         = 23
  
    
VAR
  long  seed, visitor,f, ReOpenPort
  byte TXBuffer [BTS], RXBuffer [BTR]

  
OBJ
  pst             : "Parallax Serial Terminal"
  wiz             : "W5100.spin" 
  sock[SOCKETS]   : "Socket.spin"
  dhcp            : "Dhcp" 
  str             : "STREngine"
  I2C             : "I2Ccom2"
PUB Main | i, page, dnsServer

  i := 0
  dira [LED]~~
  pst.Start(115_200)
  pause(500)

  visitor := 43900                 ' Set visitor number if you not want to start at 0 afther reset.
  
  pst.str(string("Initialize W5200", CR))

  'wiz.QS_Init
  wiz.HardReset(WIZ#WIZ_RESET)
  wiz.Start(WIZ#SPI_CS, WIZ#SPI_SCK, WIZ#SPI_MOSI, WIZ#SPI_MISO)

  wiz.HardReset(RESET_PIN)

  wiz.SetMac($00, $08, $DC, $16, $F4, $34)
  wiz.SetIp($0A, $00, $00, $37)      '10.0.0.55
  pause(1000)
  'Start I2C cog for data transfer to extern propeller chip
  I2C.init (I2Crxtx,I2Cclk,I2Ccs,BTR,BTS,@RXbuffer,@TXbuffer)
  
  pst.str(string("Getting network paramters", CR))


  PrintIp(wiz.GetIp)   
  pst.str(string("DNS..............."))
  dnsServer := wiz.GetDns
  PrintIp(wiz.GetDns)

  pst.str(string("DHCP Server......."))
  printIp(dhcp.GetDhcpServer)

  pst.str(string("Router IP........."))
  printIp(dhcp.GetRouter)
  pst.char(CR)

  repeat
    pst.str(string("Initialize Sockets",CR))
    repeat i from 0 to SOCKETS-1
      sock[i].Init(i, TCP, 5555)
           
    OpenListeners
    StartListners
    
    pst.str(string("Start Socket server",CR))
    \MultiSocketServer
    pst.str(string("I blew up!"))
    pause(5000)

PUB OpenListeners | i
  pst.str(string("Open",CR))
  repeat i from 0 to SOCKETS-1  
    sock[i].Open
      
PUB StartListners | i
  repeat i from 0 to SOCKETS-1
    if(sock[i].Listen)
      pst.str(string("Listen "))
    else
      pst.str(string("Listener failed ",CR))
    pst.dec(i)
    pst.char(CR)

PUB CloseWait | i
  repeat i from 0 to SOCKETS-1
    if(sock[i].IsCloseWait) 
      sock[i].Disconnect
      sock[i].Close
      
    if(sock[i].IsClosed)  
      sock[i].Open
      sock[i].Listen

PUB MultiSocketServer | bytesToRead, i, page, j, x , bytesSent, ptr
  bytesToRead := bytesSent := i := j := x := 0
  repeat
     visitor ++
    bytemove (@num1,STR.numberToDecimal(visitor, 7),8)

    pst.str(string(CR, "TCP Service", CR))
    CloseWait

    
    repeat until sock[i].Connected
      i := ++i // SOCKETS
      if(sock[i].IsClosed)         ' Check if sockets are open
        outa[LED]~~
        CloseWait                  ' Re-open sockets if closed
        ReOpenPort ++
        pause(500)
        outa[LED]~
        pause(500)
        
    bytemove (@reopenP,STR.numberToDecimal(ReOpenPort, 7),8)    
      
    if ina[I2Ccs]==1
      I2C.movedata  

    'Data in the buffer?
    repeat until bytesToRead := sock[i].Available
    
    'Check for a timeout
    if(bytesToRead < 0)
      pst.str(string("Timeout",CR))
      sock[i].Disconnect
      sock[i].Open
      sock[i].Listen
      bytesToRead~
      next

  
    'Get the Rx buffer  
    sock[i].Receive(@buff, bytesToRead)

    {{ Process the Rx data}}

    pst.str(string("Send Response",CR))
    page :=  ParseResource(@buff)

    pst.str(string("Byte to send "))
    pst.dec(strsize(page))
    pst.char(CR)

    bytesSent := 0
    ptr := page
    repeat until bytesSent == strsize(page)
      bytesSent += sock[i].Send(ptr, strsize(ptr))
      ptr := page + bytesSent

    pst.str(string("Bytes Sent "))
    pst.dec(bytesSent)
    pst.char(CR)

    if(sock[i].Disconnect)
      pst.str(string("Disconnected", CR))
    else
      pst.str(string("Force Close", CR))
    sock[i].Open
    sock[i].Listen
    sock[i].SetSocketIR($FF)
    
    i := ++i // SOCKETS
    bytesToRead~

PUB ParseResource(header) | ptr, value, i, done, j
  ptr := header
  i := 0
  done := false

  'bytemove (@numtest2,STR.numberToDecimal(RXbuffer[1], 1),2)  
  'bytemove (@numtest,STR.numberToDecimal(RXbuffer[0], 2),3)
  bytemove(@table[52],STR.numberToDecimal(RXbuffer[0],2),3)
  bytemove(@table[56],STR.numberToDecimal(RXbuffer[1],1),2)
  bytemove(@table2[52],STR.numberToDecimal(RXbuffer[2],2),3)
  bytemove(@table2[56],STR.numberToDecimal(RXbuffer[3],1),2)

    if RXbuffer[4]==1
      bytemove(@table3[50],string ("-"),1)
      bytemove(@table3[52],STR.numberToDecimal((127-RXbuffer[5]),2),3)      
    if RXbuffer[4]==0
      bytemove(@table3[50],string ("+"),1)
      bytemove(@table3[52],STR.numberToDecimal(RXbuffer[5],2),3)      
    if RXbuffer[6]==0  
      bytemove(@table3[56],string ("0"),1)
    if RXbuffer[6]<>0
      bytemove(@table3[56],string ("5"),1)

    if RXbuffer[7]==1
      bytemove(@table4[50],string ("-"),1)
      bytemove(@table4[52],STR.numberToDecimal((127-RXbuffer[8]),2),3)      
    if RXbuffer[7]==0
      bytemove(@table4[50],string ("+"),1)
      bytemove(@table4[52],STR.numberToDecimal(RXbuffer[8],2),3)      
    if RXbuffer[9]==0  
      bytemove(@table4[56],string ("0"),1)
    if RXbuffer[9]<>0
      bytemove(@table4[56],string ("5"),1)  

    if RXbuffer[10]==0
      bytemove(@table5[50],string ("OFF"),3)
    else
      bytemove(@table5[50],string (" ON"),3)

    bytemove(@table6[50],STR.numberToDecimal(RXbuffer[31],2),3)
    bytemove(@table6[54],STR.numberToDecimal(RXbuffer[32],2),3)
    bytemove(@table6[58],STR.numberToDecimal(2000+(RXbuffer[33]),4),5)
    bytemove(@table6[68],STR.numberToDecimal(RXbuffer[34],2),3)
    bytemove(@table6[73],STR.numberToDecimal(RXbuffer[35],2),3)

    bytemove(@table7[56],STR.numberToDecimal(RXbuffer[24],2),3)
    bytemove(@table7[60],STR.numberToDecimal(RXbuffer[26],1),2)
    bytemove(@table8[56],STR.numberToDecimal(RXbuffer[25],2),3)
    bytemove(@table8[60],STR.numberToDecimal(RXbuffer[27],1),2)
    if RXbuffer[28]==1
      bytemove(@table9[54],string ("-"),1)
      bytemove(@table9[56],STR.numberToDecimal((127-RXbuffer[29]),2),3)      
    if RXbuffer[28]==0
      bytemove(@table9[54],string ("+"),1)
      bytemove(@table9[56],STR.numberToDecimal(RXbuffer[29],2),3)      
    if RXbuffer[30]==0  
      bytemove(@table9[60],string ("0"),1)
    if RXbuffer[30]<>0
      bytemove(@table9[60],string ("5"),1)
 
    bytemove(@table10[56],STR.numberToDecimal(RXbuffer[22],2),3)
    bytemove(@table10[60],STR.numberToDecimal(RXbuffer[23],1),2)
      
    bytemove(@table11[50],STR.numberToDecimal(RXbuffer[41],2),3)          '50
    bytemove(@table11[54],STR.numberToDecimal(RXbuffer[42],2),3)          '54
    bytemove(@table11[58],STR.numberToDecimal(2000+(RXbuffer[43]),4),5)   '58
    bytemove(@table11[68],STR.numberToDecimal(RXbuffer[44],2),3)          '66
    bytemove(@table11[73],STR.numberToDecimal(RXbuffer[45],2),3)          '71

    bytemove(@Tcat[0],STR.numberToDecimal(RXbuffer[46],2),3)
    bytemove(@Tcat[4],STR.numberToDecimal(RXbuffer[47],1),2)
    if RXbuffer[48]==1
      bytemove(@home,string("AT HOME      "),13)
    if RXbuffer[48]==0
      bytemove(@home,string("OUT HUNTING.."),13)  
   
    bytemove(@Tpool[0],STR.numberToDecimal(RXbuffer[11],2),3)
    bytemove(@solarP[0],STR.numberToDecimal(RXbuffer[13],2),3)
    bytemove(@Ttank[0],STR.numberToDecimal(RXbuffer[15],2),3)
    bytemove(@solarS[0],STR.numberToDecimal(RXbuffer[17],2),3)
    if RXbuffer[19]==1
      bytemove(@filter,string("ON "),3)
    if RXbuffer[19]==0
      bytemove(@filter,string("OFF"),3)
    if RXbuffer[20]==1
      bytemove(@SHpool,string("ON "),3)
    if RXbuffer[20]==0
      bytemove(@SHpool,string("OFF"),3)
    if RXbuffer[21]==1
      bytemove(@SHshow,string("ON "),3)
    if RXbuffer[21]==0
      bytemove(@SHshow,string("OFF"),3)
    bytemove(@table12[62],STR.numberToDecimal(RXbuffer[36],2),3)          '50
    bytemove(@table12[66],STR.numberToDecimal(RXbuffer[37],2),3)          '54
    bytemove(@table12[70],STR.numberToDecimal(2000+(RXbuffer[38]),4),5)   '58
    bytemove(@table12[80],STR.numberToDecimal(RXbuffer[39],2),3)          '66
    bytemove(@table12[85],STR.numberToDecimal(RXbuffer[40],2),3)          '71
    
    if RXbuffer[49]==1
      bytemove(@Tin[0],string ("-"),1)
    if RXbuffer[49]==0
      bytemove(@Tin[0],string (" "),1)        
    bytemove(@Tin[1],STR.numberToDecimal(RXbuffer[50],2),3)      
    bytemove(@Tin[5],STR.numberToDecimal(RXbuffer[51],1),2)
     
    if RXbuffer[52]==1
      bytemove(@Tpre[0],string ("-"),1)
    if RXbuffer[52]==0
      bytemove(@Tpre[0],string (" "),1)        
    bytemove(@Tpre[1],STR.numberToDecimal(RXbuffer[53],2),3)      
    bytemove(@Tpre[5],STR.numberToDecimal(RXbuffer[54],1),2)

    if RXbuffer[55]==1
      bytemove(@Tsup[0],string ("-"),1)
    if RXbuffer[55]==0
      bytemove(@Tsup[0],string (" "),1)        
    bytemove(@Tsup[1],STR.numberToDecimal(RXbuffer[56],2),3)      
    bytemove(@Tsup[5],STR.numberToDecimal(RXbuffer[57],1),2)

    if RXbuffer[58]==1
      bytemove(@Text[0],string ("-"),1)
    if RXbuffer[58]==0
      bytemove(@Text[0],string (" "),1)        
    bytemove(@Text[1],STR.numberToDecimal(RXbuffer[59],2),3)      
    bytemove(@Text[5],STR.numberToDecimal(RXbuffer[60],1),2)

    if RXbuffer[61]==1
      bytemove(@Texh[0],string ("-"),1)
    if RXbuffer[61]==0
      bytemove(@Texh[0],string (" "),1)        
    bytemove(@Texh[1],STR.numberToDecimal(RXbuffer[62],2),3)      
    bytemove(@Texh[5],STR.numberToDecimal(RXbuffer[63],1),2)

    bytemove(@Eff[0],STR.numberToDecimal(RXbuffer[64],2),3)
    bytemove(@snow[0],STR.numberToDecimal(RXbuffer[67],2),3)
    if RXbuffer[68]==1
      bytemove(@wingen,string("STARTED"),7)
    if RXbuffer[68]==0
      bytemove(@wingen,string("STOPPED"),7)

    if RXbuffer[65]==1
      bytemove(@Fsup[0],string ("CLOGGED"),7)
    else
      bytemove(@Fsup[0],string ("     OK"),7)

    if RXbuffer[66]==1
      bytemove(@Fext[0],string ("CLOGGED"),7)
    else
      bytemove(@Fext[0],string ("     OK"),7)

    if RXbuffer[128]==1
      bytemove(@Stat,string("STARTED"),7)
    if RXbuffer[128]==0
      bytemove(@Stat,string("STOPPED"),7)
      
    if RXbuffer[136]==1
      bytemove(@Mode,string("  AUTO"),6)
    if RXbuffer[136]==0
      bytemove(@Mode,string("MANUEL"),6)

    if RXbuffer[108]==1
      bytemove(@RegType,string("WATER LEVEL"),11)
    if RXbuffer[108]==0
      bytemove(@RegType,string("   INTERVAL"),11)

    if RXbuffer[109]==1
      bytemove(@AR,string(" ON"),3)
    if RXbuffer[109]==0
      bytemove(@AR,string("OFF"),3)  
                  
    bytemove(@Forcing[0],STR.numberToDecimal(((RXbuffer[98]*100)/175),3),4)
    bytemove(@Freq[0],STR.numberToDecimal(RXbuffer[78],2),3)
    bytemove(@Freq[4],STR.numberToDecimal(RXbuffer[79],2),3)
    bytemove(@Pwr[0],STR.numberToDecimal(RXbuffer[76],1),2)
    bytemove(@Pwr[3],STR.numberToDecimal(RXbuffer[77],2),3)
    bytemove(@RpmT,STR.numberToDecimal((RXbuffer[70]<<8 + RXbuffer[71]),3),4)
    bytemove(@RpmG,STR.numberToDecimal((RXbuffer[72]<<8 + RXbuffer[73]),4),5)
    bytemove(@L1,STR.numberToDecimal(RXbuffer[83],3),4)
    bytemove(@L2,STR.numberToDecimal(RXbuffer[82],3),4)
    bytemove(@L3,STR.numberToDecimal(RXbuffer[81],3),4)
    bytemove(@L1L2,STR.numberToDecimal(RXbuffer[86],3),4)
    bytemove(@L2L3,STR.numberToDecimal(RXbuffer[85],3),4)
    bytemove(@L3L1,STR.numberToDecimal(RXbuffer[84],3),4)
    bytemove(@batt[0],STR.numberToDecimal(RXbuffer[87]/10,2),3)
    bytemove(@batt[4],STR.numberToDecimal(RXbuffer[87]//10,1),2)
    bytemove(@Tgen,STR.numberToDecimal(RXbuffer[88],2),3)
    bytemove(@TB1,STR.numberToDecimal(RXbuffer[90],2),3)
    bytemove(@TB2,STR.numberToDecimal(RXbuffer[91],2),3)
    bytemove(@TW,STR.numberToDecimal(RXbuffer[92],2),3)
    if RXbuffer[96]==0
      bytemove(@Dam,string("  0"),3)
    else  
      bytemove(@Dam,STR.numberToDecimal(((RXbuffer[96]-53)*100)/44,3),4)    'Ai[9]-53)*100)/44
    if RXbuffer[101]==0
      bytemove(@RegLev,string("  0"),3)
    else 
      bytemove(@RegLev,STR.numberToDecimal(((RXbuffer[101]-53)*100)/44,3),4)
    if RXbuffer[99]==0
      bytemove(@StaLev,string("  0"),3)
    else  
      bytemove(@StaLev,STR.numberToDecimal(((RXbuffer[99]-53)*100)/44,3),4)
    if RXbuffer[100]==0
      bytemove(@StoLev,string("  0"),3)
    else  
      bytemove(@StoLev,STR.numberToDecimal(((RXbuffer[100]-53)*100)/44,3),4)
    if RXbuffer[97]==0
      bytemove(@Tpress,string(" 0"),2)
      bytemove(@Tpress[4],string(" 0"),2)
    else  
      bytemove(@Tpress,STR.numberToDecimal((((RXbuffer[97]-27)*100)/40/100),1),2) '(((Ai[10]-27)*100)/40)/10
      bytemove(@Tpress[3],STR.numberToDecimal((((RXbuffer[97]-27)*100)/40//100),2),3)
  
    if RXbuffer[144]<>0or RXbuffer[145]<>0or RXbuffer[146]<>0or RXbuffer[147]<>0or RXbuffer[148]<>0or RXbuffer[149]<>0or RXbuffer[150]<>0or RXbuffer[151]<>0or RXbuffer[152]<>0or RXbuffer[153]<>0or RXbuffer[154]<>0or RXbuffer[155]<>0or RXbuffer[156]<>0
      bytemove(@AlrmOK,string("     "),5)
      bytemove(@Alarms,string("ALARM"),5)      
    else
      bytemove(@Alarms,string("     "),5)
      bytemove(@AlrmOK,string("   OK"),5)


   if RXbuffer[195]==1
      bytemove(@lc,string(" ON"),3)
   if RXbuffer[195]==0
      bytemove(@lc,string("OFF"),3)
   if RXbuffer[199]==1
      bytemove(@loop,string("  OPEN"),6)
   if RXbuffer[199]==0
      bytemove(@loop,string("CLOSED"),6)
   if RXbuffer[194]==1
      bytemove(@mower,string("CHARGING"),8)
   if RXbuffer[194]==0
      bytemove(@mower,string("  MOWING"),8)
          
   if RXbuffer[191]>10
      bytemove(@dwl,string(" OK"),3)
   else
      bytemove(@dwl,string("LOW"),3)
   if RXbuffer[202]==1
      bytemove(@dfp,string(" ON"),3)
   else
      bytemove(@dfp,string("OFF"),3)
   if RXbuffer[190]=>2
      bytemove(@rsen,string("WET"),3)
   else
      bytemove(@rsen,string("DRY"),3)
   if RXbuffer[203]==1
      bytemove(@gli,string(" ON"),3)
   else
      bytemove(@gli,string("OFF"),3)

            
  repeat until IsEndOfLine(byte[ptr])
    if(IsToken(byte[ptr]))
      byte[ptr] := 0
      resPtr[i++] := ++ptr
    else
      ++ptr

    if(ptr - header > 500)
      pst.str(string(CR, "+++++++++++++++[ERROR]++++++++++++++",CR))
      return @index
      
  resPtr[0] := header

  repeat j from 0 to i-1
    if(strcomp(resPtr[j], string("HTTP")))     
      return @index

    if(strcomp(resPtr[j], string("la6wna")))     
      return @la6wna

    if(strcomp(resPtr[j], string("cabin")))
      return @cabin  
   
    if(strcomp(resPtr[j], string("weatherst")))
      return @weatherst
      
    if(strcomp(resPtr[j], string("garden")))
      return @garden
      
    if(strcomp(resPtr[j], string("cat")))
      return @cat

    if(strcomp(resPtr[j], string("pool")))
      return @pool

    if(strcomp(resPtr[j], string("ventil")))
      return @ventilation

    if(strcomp(resPtr[j], string("powerst")))
      return @hydropowerst
    if(strcomp(resPtr[j], string("powerst2")))
      return @hydropowerst2    
      
          
    if(strcomp(resPtr[j], string("UpdateHut")))'and f==0)'outa[23]==0)
       if ina[I2Ccs]==1
         TXbuffer[0]:=10
         I2C.movedata
         I2C.startsend
         TXbuffer[0]:=0
         pause(500)   
         I2C.movedata
         I2C.startsend
      return @radiocallCabin
      
    if(strcomp(resPtr[j], string("UpdateWeather")))'and f==0)'outa[23]==0)
       if ina[I2Ccs]==1
         TXbuffer[0]:=15
         I2C.movedata
         I2C.startsend
         TXbuffer[0]:=0
         pause(500)   
         I2C.movedata
         I2C.startsend
      return @radiocallWeather
      
    if(strcomp(resPtr[j], string("UpdatePool")))'and f==0)'outa[23]==0)
       if ina[I2Ccs]==1
         TXbuffer[0]:=27
         I2C.movedata
         I2C.startsend
         TXbuffer[0]:=0
         pause(500)   
         I2C.movedata
         I2C.startsend
      return @radiocallPool
   


PUB IsToken(value)
  return lookdown(value: "/", "?", "=", " ")

PUB IsEndOfLine(value)
  return lookdown(value: CR, LF)


     
PUB PrintIp(addr) | i
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)
    else
      pst.char($0D)
  
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return
    
PRI StringSend(socket, _dataPtr)
  wiz.tx(socket, _dataPtr, strsize(_dataPtr))       


    
DAT

  buff          byte  $0[BUFFER_2K] 
  resPtr        long $0[25]
  null          long  $00
  dhcpLease     long  $00

{HTML web pages}
'-------------------------------------------------------------------------------------   
radiocallCabin
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte   "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>PMR Radio Call</TITLE>"
        byte  "</HEAD>"   
        byte  "<BODY>"
        byte  "<FONT FACE=ARIAL SIZE=6>"
        byte  "Radio calls for update...<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>Please wait for 8 sec. Page will reload automaticly.<BR><BR><BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=20 COLOR=blue>#---/---#<BR>" 
        'byte  "<marquee behavior=alternate scrollamount=80><img src=http://www.quackit.com/pix/tennis_ball.png width=33 height=34 alt=Bouncing ball /></marquee>"
        'byte  "<marquee behavior=scroll  direction=left><img src=http://www.quackit.com/pix/web_graphics/free_website_graphics/clip_arts/bats_013.gif width=125 height=82 alt=Flying Bat /></marquee>"
        'byte  "<marquee behavior=scroll direction=right><img src=http://www.quackit.com/pix/web_graphics/free_website_graphics/clip_arts/bats_013.gif width=125 height=82 alt=Flying Bat /></marquee>"
        byte  "<meta http-equiv=refresh content=8;url=http://spinneret.la6wna.com/cabin>" 
        byte   "</FONT>"
        byte   "</BODY>"
        byte   "</HTML>"
        byte  0
'--------------------------------------------------------------------------------------
radiocallWeather
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte   "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>PMR Radio Call</TITLE>"
        byte  "</HEAD>"   
        byte  "<BODY>"
        byte  "<FONT FACE=ARIAL SIZE=6>"
        byte  "Radio calls for update...<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>Please wait for 8 sec. Page will reload automaticly.<BR><BR><BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=20 COLOR=blue>#---/---#<BR>"
        'byte  "<marquee behavior=alternate scrollamount=80><img src=http://www.quackit.com/pix/tennis_ball.png width=33 height=34 alt=Bouncing ball /></marquee>"
        byte  "<meta http-equiv=refresh content=8;url=http://spinneret.la6wna.com/weatherst>"
        byte   "</FONT>"
        byte   "</BODY>"
        byte   "</HTML>"
        byte  0
'--------------------------------------------------------------------------------------
radiocallPool
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte   "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>PMR Radio Call</TITLE>"
        byte  "</HEAD>"   
        byte  "<BODY>"
        byte  "<FONT FACE=ARIAL SIZE=6>"
        byte  "Radio calls for update...<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=8 COLOR=RED>"
        byte  "NOTE : "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=BLUE>" 
        byte  "Dont expect update response between September and May. Pool closed in wintertime.<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>Please wait for 8 sec. Page will reload automaticly.<BR><BR><BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=20 COLOR=blue>#---/---#<BR>"
        'byte  "<marquee behavior=alternate scrollamount=80><img src=http://www.quackit.com/pix/tennis_ball.png width=33 height=34 alt=Bouncing ball /></marquee>"
        byte  "<meta http-equiv=refresh content=8;url=http://spinneret.la6wna.com/pool>"
        byte   "</FONT>"
        byte   "</BODY>"
        byte   "</HTML>"
        byte  0        
'--------------------------------------------------------------------------------------
la6wna  byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<BODY>"
        byte  "<meta http-equiv=refresh content=0;url=http://la6wna.com/>"
        byte   "</BODY>"
        byte   "</HTML>"
        byte  0

'--------------------------------------------------------------------------------------

index   byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Spinneret Web Server</TITLE>"
        byte  "</HEAD>"   
        byte  "<BODY>"
        byte  "<FONT FACE=ARIAL SIZE=8>Hello everyone!"
        byte  "<FONT FACE=ARIAL SIZE=4><BR>"
        byte  "You have connected to LA6WNA`s PARALLAX Spinneret Web Server "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=GREEN><BR><BR>Server hits : "
num1    byte  "0000000 " '<BR>" '<--- This is a place holder ; number is dynamically updated
        byte  "**********Automatic port reopenings since last reset : "
reopenP byte  "        <BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cat'><FONT COLOR=RED  >Cathouse</FONT></BUTTON>" 
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cabin'><FONT COLOR=RED  >My Cabin</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='weatherst'><FONT COLOR=RED  >Weather Station</FONT></BUTTON>" 
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='la6wna'><FONT COLOR=BLUE  >LA6WNA Homepage</FONT></BUTTON><BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='pool'><FONT COLOR=RED  >My Pool</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='ventil'><FONT COLOR=RED  >Ventilation</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='powerst'><FONT COLOR=RED  >Hydro Power</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='garden'><FONT COLOR=RED  >Garden Control</FONT></BUTTON>"  
        byte  "</FORM>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=RED><BR><BR>"
        byte  "July 3. 2015 : Added data from Garden Controller<BR> Have a nice summer, folks!"
        'byte  "Merry X-mas to all of you <BR> and  Happy New Year 2015" 
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=BLUE><BR><BR><BR><BR>"
        byte  "Pages can still be modified when trying out new codes.<BR><BR>"
        byte  "My Spinneret Web Server contains data from some of my technical installations.<BR>"
        byte  "Data is collected by a separate Propeller chip, via modem and PMR radios and RS-485 bus.<BR> "
        byte  "This is a 'newer ending project', so the pages will change from time to time.<BR>"
        byte  "I`m planning to get more of my installations 'online' aftherwards, so hang on...<BR>"
        byte  "</FONT>"
        byte  "</BODY>"
        byte  "</HTML>"
        byte  0

'--------------------------------------------------------------------------------------
cabin   byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Cabin</TITLE>"
        byte  "</HEAD>"   
        byte  "<BODY>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=BLUE>CONDITION IN MY CABIN:<img border=0 align=left src=http://home.online.no/~kaare.ar/artimages/DSCN5255.JPG width=300 height=200 /><BR>"
table   byte  "<table border=2><tr><th>Battery Windpower</th><td>  ---,-  Volts </td></tr>"
table2  byte  "<table border=2><tr><th>Battery SolarCell</th><td>  ---,-  Volts </td></tr>"
table3  byte  "<table border=2><tr><th>Temp outdoor     </th><td>  ---,-  C   </td></tr>"
table4  byte  "<table border=2><tr><th>Temp indoor      </th><td>  ---,-  C   </td></tr>"
table5  byte  "<table border=2><tr><th>Webasto heater   </th><td> .. </td></tr>"
table6  byte  "<table border=9><tr><th>Last Update     :</th><td>   .   .20    Clk.    :   </td></tr>"
        byte  "</table>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black><BR><BR>Snow depth***** :  "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=blue>"
snow    byte  "      cm<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Wind-Generator :  "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=blue>"
wingen  byte  "       "
        byte  "<BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='UpdateHut'><FONT COLOR=BLACK  >Update Now?</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='weatherst'><FONT COLOR=RED  >Weather Station</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='la6wna'><FONT COLOR=BLUE  >LA6WNA Homepage</FONT></BUTTON>"  
        byte  "</FORM>"
        byte  "</FONT>"
        byte  "</BODY>"
        byte  "</HTML>"
        byte  0

'--------------------------------------------------------------------------------------
weatherst
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Weather ST</TITLE>"
        byte  "</HEAD>"
        byte  "<BODY>"          
       ' byte  "<FONT FACE=ARIAL SIZE=6 COLOR=GREEN><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=purple>WEATHER STATION (abt 200m above sea level):<img border=0 align=left src=http://home.online.no/~kaare.ar/artimages/DSCN6823.JPG width=400 height=300 /><BR>"
table7  byte  "<table border=2><tr><th>Windspeed at uppdate </th><td>  ---,-  m/sec</td></tr>"
table8  byte  "<table border=2><tr><th>Max wind last 24h    </th><td>  ---,-  m/sec</td></tr></table><FONT FACE=ARIAL SIZE=1 COLOR=red>(Gets reset at 07:00 in the morning)"
table9  byte  "<table border=2><tr><th>Temperature          </th><td>  ---,-  C   </td></tr>"
table10 byte  "<table border=2><tr><th>Battery power        </th><td>  ---,-  Volts</td></tr>"
table11 byte  "<table border=9><tr><th>Last Update     :</th><td>   .   .20    Clk.    :   </td></tr>"
        byte  "</table>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=GREEN><BR><BR><BR><BR><BR>"                                    
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='UpdateWeather'><FONT COLOR=BLACK  >Update Now?</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cabin'><FONT COLOR=RED  >My Cabin</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='la6wna'><FONT COLOR=BLUE  >LA6WNA Homepage</FONT></BUTTON>" 
        byte  "</FORM>"
        byte  "</FONT>"
        byte  "</BODY>"
        byte  "</HTML>"
        byte  0

'--------------------------------------------------------------------------------------
garden
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Garden</TITLE>"    
        byte  "</HEAD>"                                                                                                                                                
        byte  "<BODY>"
        byte  "<FONT FACE=ARIAL SIZE=8 COLOR=green>GARDEN CONTROL<BR><BR>"
        
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>LAWNMOWER<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Loop Control_________:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
lc      byte  "    <BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Loop Area 2_________:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
loop    byte  "       <BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Lawnmower_________:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
mower   byte  "         <BR>"
        
        byte  "<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>GARDEN DAM<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Dam water level____:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
dwl     byte  "    <BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Fountain Pump____:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
dfp     byte  "    <BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Rain Sensor_______:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
rsen    byte  "    <BR><BR>"

        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>GARDEN LIGHTS<BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
gli     byte  "    <BR>"
           
        byte  "<BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        byte  "</FORM>"
        byte  "</div>"  
        byte  "</BODY>" 
        byte  "</HTML>"
        byte  0        

'--------------------------------------------------------------------------------------
{test1   byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Testpage</TITLE>"                                                                                                 ';border:1px solid black
        
        'byte  "background: url(http://home.online.no/~kaare.ar/artimages/ACFJAAbabyN4.jpg) 50% 50% no-repeat;"       'background-position: 50% 50%;
        byte  "</HEAD>"                                                                                                                                                 ';width:1500px;height:300px
        byte  "<BODY>"                                                                                     'padding:5px;             '
        byte  "<div style=background-image:url(http://home.online.no/~kaare.ar/artimages/DSCN6550.JPG);width:500px;height:500px;background-repeat:no-repeat;>"

        byte  "<FONT FACE=ARIAL SIZE=8 COLOR=red>TESTING AREA...<BR><BR><BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=2 COLOR=yellow>This is a test page for testing HTML-codes.<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=blue>Just now, testing background image code.<BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON></FORM>"
        byte  "</div>"  
        byte  "</BODY>" 
        byte  "</HTML>"
        byte  0                }
                                                                                   
'-------------------------------------------------------------------------------------
cat     byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Cathouse</TITLE>"    
        byte  "</HEAD>"                                                                                                                                                
        byte  "<BODY>"                                                                                               
        byte  "<div style=background-image:url(http://home.online.no/~kaare.ar/artimages/DSCN6857.JPG);width:913px;height:665px;background-repeat:no-repeat;>"

        byte  "<FONT FACE=ARIAL SIZE=8 COLOR=blue>ROCKY  CAT<BR><BR><BR><BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Temperature in the cathouse just now : "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Tcat    byte  "   ,   C<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Rocky are just now : "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
home    byte  "              "
        byte  "<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=2 COLOR=black>(Cathouse conditions are auto-updating once every minute. Refresh your browser to get latest values.)<BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='weatherst'><FONT COLOR=RED  >Weather Station</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cabin'><FONT COLOR=RED  >My Cabin</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='la6wna'><FONT COLOR=BLUE  >LA6WNA Homepage</FONT></BUTTON>"
        byte  "</FORM>"
        byte  "</div>"  
        byte  "</BODY>" 
        byte  "</HTML>"
        byte  0

'-------------------------------------------------------------------------------------
pool    byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Pool</TITLE>"    
        byte  "</HEAD>"                                                                                                                                                
        byte  "<BODY>"
        byte  "<img border=0 align=left src=http://home.online.no/~kaare.ar/artimages/DSCN6138.JPG width=600 height=400 />"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=blue>Pool Temp.................: " 
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Tpool   byte  "    C<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=blue>Solar Pool-Heaters....: " 
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
solarP  byte  "    C<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=blue>Shower Tank Temp....: " 
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Ttank   byte  "    C<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=blue>Solar Shower-Heaters: " 
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
solarS  byte  "    C<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=green>Pool Filter Pump.........:" 
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
filter  byte  "    <BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=green>Solar Heaters Pump...:" 
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
SHpool  byte  "    <BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=green>Solar Shower Pump....:" 
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
SHshow  byte  "    <BR><BR>"
table12 byte  "<table border=6 align= left><tr><th>Last Update     :</th><td>   .   .20    Clk.    :   </td></tr>"
        byte  "</table><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=GREEN><BR>" 
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>POOL IS CLOSED IN THE WINTERTIME. OPENS AGAIN IN MAY/JUNE 2015. <BR>"
        'byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>Pool opened at April 20. 2014. <BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='UpdatePool'><FONT COLOR=BLACK  >Update Now?</FONT></BUTTON>" 
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='weatherst'><FONT COLOR=RED  >Weather Station</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cabin'><FONT COLOR=RED  >My Cottage</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='la6wna'><FONT COLOR=BLUE  >LA6WNA Homepage</FONT></BUTTON>"
        
       
        byte  "</FORM>"   
        byte  "</div>"  
        byte  "</BODY>" 
        byte  "</HTML>"
        byte  0

'---------------------------------------------------------------------------------------
ventilation
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Ventilation</TITLE>"    
        byte  "</HEAD>"                                                                                                                                                
        byte  "<BODY>"

        byte  "<FONT FACE=ARIAL SIZE=8 COLOR=blue>HOME VENTILATION SYSTEM<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Outdoor air temp________: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Tin     byte  "    ,   C<BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Preheated air temp______: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Tpre    byte  "    ,   C<BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Supply air temp_________: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Tsup    byte  "    ,   C<BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Extract air temp_________: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Text    byte  "    ,   C<BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Exhaust air temp________: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Texh    byte  "    ,   C<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Heat recovery____________: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Eff     byte  "    %" 
        byte  "<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Supply filter____________: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Fsup    byte  "       "  '7 char
        byte  "<BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>Exhaust filter___________: "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Fext    byte  "       "  '7 char
        byte  "<BR><BR>"
        'byte  "<FONT FACE=ARIAL SIZE=2 COLOR=black>(Cathouse conditions are auto-updating once every minute. Refresh your browser to get latest values.)<BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='weatherst'><FONT COLOR=RED  >Weather Station</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cabin'><FONT COLOR=RED  >My Cabin</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='la6wna'><FONT COLOR=BLUE  >LA6WNA Homepage</FONT></BUTTON>"
        byte  "</FORM>"
        byte  "</div>"  
        byte  "</BODY>" 
        byte  "</HTML>"
        byte  0

'------------------------------------------------------------------------------------
hydropowerst
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Hydro-Power</TITLE>"    
        byte  "</HEAD>"                                                                                                                                                
        byte  "<BODY>"

        byte  "<FONT FACE=ARIAL SIZE=8 COLOR=green>HYDRO POWER STATION<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Status  : "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=blue>"
Stat    byte  "        " '7 char
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Mode  : "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=blue>"
Mode    byte  "       "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Regulation type  : "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=blue>"
RegType byte  "            "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Auto-return  : "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=blue>"
AR      byte  "    <BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Forcing_________"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
Forcing byte  "    _%<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Output power____"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
Pwr     byte  "  ,   _kW<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Turbine Speed___"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
RpmT    byte  "    _rpm<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Generator Speed_"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
RpmG    byte  "      _rpm<BR><BR>"        
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Voltages__"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>L1 :"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
L1      byte  "    _V"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black> ___L2 :"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
L2      byte  "    _V"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black> ___L3 :"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
L3      byte  "    _V"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>_____L1-L2 :"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
L1L2    byte  "    _V"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>___L2-L3 :"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
L2L3    byte  "    _V"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>___L3-L1 :"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
L3L1    byte  "    _V<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Mains frequency  : "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
Freq    byte  "   ,   _Hz<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Station battery :"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
batt    byte  "   ,   _V<BR>"        
        byte  "<BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='weatherst'><FONT COLOR=RED  >Weather Station</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cabin'><FONT COLOR=RED  >My Cabin</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='powerst2'><FONT COLOR=BLACK  >NEXT</FONT></BUTTON>"
        byte  "</FORM>"
        byte  "</div>"  
        byte  "</BODY>" 
        byte  "</HTML>"
        byte  0

hydropowerst2
        byte  "HTTP/1.1 200 OK", CR, LF
        byte  "Content-Type: text/html", CR, LF,CR,LF
        byte  "<HTML>"
        byte  "<HEAD>"
        byte  "<TITLE>LA6WNA Hydro-Power</TITLE>"    
        byte  "</HEAD>"                                                                                                                                                
        byte  "<BODY>"

        byte  "<FONT FACE=ARIAL SIZE=8 COLOR=green>HYDRO POWER STATION"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>(Page 2)<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>TEMPERATURES<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Generator main coil____:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
Tgen    byte  "   _C<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Turbine front bearing___:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
TB1     byte  "   _C<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Turbine rear bearing___:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
TB2     byte  "   _C<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Water temperature_____:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
TW      byte  "   _C<BR>"
        byte  "<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>DAM AND SETTINGS<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Dam water level____:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
Dam     byte  "    _Cm<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Regulation level____:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
RegLev  byte  "    _Cm<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Start level_________:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
StaLev  byte  "    _Cm<BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Stop level_________:"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
StoLev  byte  "    _Cm<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=black>Turbine pressure___: "
        byte  "<FONT FACE=ARIAL SIZE=4 COLOR=red>"
Tpress  byte  "  ,   _Bar"
        byte  "<BR><BR>"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=black>ALARMS__:"
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=red>"
Alarms  byte  "      "
        byte  "<FONT FACE=ARIAL SIZE=6 COLOR=green>"
AlrmOK  byte  "      "        
        byte  "<BR><BR>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='index'><FONT COLOR=GREEN  >Spinneret Home</FONT></BUTTON>"
        byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='powerst'><FONT COLOR=BLACK  >BACK</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='cabin'><FONT COLOR=RED  >My Cabin</FONT></BUTTON>"
        'byte  "<FORM ACTION='get'><BUTTON TYPE='submit' NAME='powerst2'><FONT COLOR=BLACK  >NEXT</FONT></BUTTON>"
        byte  "</FORM>"
        byte  "</div>"  
        byte  "</BODY>" 
        byte  "</HTML>"
        byte  0        
              